# TODO:
# - system boxfort (when released): https://github.com/diacritic/BoxFort
# - system nanopb (0.4.7 bundled)
# - system libcsptr (when some post-2017 release made): https://github.com/Snaipe/libcsptr
#
# Conditional build:
%bcond_without	tests		# testing
%bcond_without	system_nanopb	# system nanopb
#
Summary:	A cross-platform C and C++ unit testing framework for the 21th century
Summary(pl.UTF-8):	Wieloplatformowy szkielet do testów jednostkowych dla C i C++ w XXI wieku
Name:		criterion
Version:	2.4.2
Release:	3
License:	LGPL v2.1+
Group:		Libraries
#Source0Download: https://github.com/Snaipe/Criterion/releases
Source0:	https://github.com/Snaipe/Criterion/releases/download/v%{version}/%{name}-%{version}.tar.xz
# Source0-md5:	20affc64bb0d00953826eba4c93bf8ab
Patch0:		x32.patch
Patch1:		%{name}-shared-nanopb.patch
URL:		https://github.com/Snaipe/Criterion
%{?with_system_nanopb:BuildRequires:	cmake}
BuildRequires:	dyncall >= 1.0
BuildRequires:	gettext-tools
BuildRequires:	libffi-devel
BuildRequires:	libgit2-devel
BuildRequires:	meson >= 0.55.0
BuildRequires:	nanomsg-devel >= 1.0.0
%{?with_system_nanopb:BuildRequires:	nanopb-devel >= 0.4.7}
BuildRequires:	ninja
BuildRequires:	pkgconfig
BuildRequires:	protobuf
BuildRequires:	rpmbuild(macros) >= 1.736
BuildRequires:	sed >= 4.0
BuildRequires:	tar >= 1:1.22
BuildRequires:	xz
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
A dead-simple, yet extensible, C and C++ unit testing framework.

%description -l pl.UTF-8
Bardzo prosty, ale rozszerzalny szkielet testów jednostkowych dla C i
C++.

%package devel
Summary:	Header files for criterion library
Summary(pl.UTF-8):	Pliki nagłówkowe biblioteki criterion
Group:		Development/Libraries
Requires:	%{name} = %{version}-%{release}
Requires:	libstdc++-devel

%description devel
Header files for criterion library.

%description devel -l pl.UTF-8
Pliki nagłówkowe biblioteki criterion.

%package static
Summary:	Static criterion libraries
Summary(pl.UTF-8):	Statyczne biblioteki criterion
Group:		Development/Libraries
Requires:	%{name} = %{version}-%{release}

%description static
Static criterion libraries.

%description static -l pl.UTF-8
Statyczne biblioteki criterion.

%prep
%setup -q
%patch0 -p1
%patch1 -p1

%if %{without system_nanopb}
%{__sed} -i -e '/dependency.*nanopb/ s/nanopb::protobuf-nanopb/notfound::protobuf-nanopb/' meson.build
%endif

%build
%meson build \
	-Dtests=%{__true_false tests}

%ninja_build -C build

%{?with_tests:%ninja_test -C build}

%install
rm -rf $RPM_BUILD_ROOT

%ninja_install -C build

%find_lang criterion

%clean
rm -rf $RPM_BUILD_ROOT

%post	-p /sbin/ldconfig
%postun	-p /sbin/ldconfig

%files -f criterion.lang
%defattr(644,root,root,755)
%doc ChangeLog doc/*.txt
%attr(755,root,root) %{_libdir}/libcriterion.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libcriterion.so.3

%files devel
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libcriterion.so
%{_includedir}/criterion
%{_pkgconfigdir}/criterion.pc

%files static
%defattr(644,root,root,755)
%{_libdir}/libcriterion.a
%if %{without system_nanopb}
%{_libdir}/libprotobuf_nanopb_static.a
%endif
%changelog
* Thu Dec 12 2024 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/criterion.git;a=log;h=master

* Thu Dec 12 2024 Jan Palus <atler@pld-linux.org> b392120
- libgit2 1.8 rebuild

* Tue Nov 21 2023 Jan Palus <atler@pld-linux.org> f66a0ea
- libgit2 1.7.x rebuild

* Thu Nov 16 2023 Jan Palus <atler@pld-linux.org> 78efd7c
- BR: gettext-tools

* Thu Nov 16 2023 Jan Palus <atler@pld-linux.org> 7e71641
- BR: protobuf for protoc

* Fri Sep 01 2023 Jan Palus <atler@pld-linux.org> 81a48b9
- nanopb detection uses cmake

* Fri Sep 01 2023 Jan Palus <atler@pld-linux.org> 593cad5
- BR: pkgconfig

* Fri Sep 01 2023 Jakub Bogusz <qboosh@pld-linux.org> c0cb262
- updated to 2.4.2, reenabled system nanopb

* Sat Aug 26 2023 Jan Palus <atler@pld-linux.org> dfc01d3
- libgit2 1.6 rebuild

* Sun Feb 12 2023 Jakub Bogusz <qboosh@pld-linux.org> bb94a04
- release 4 (libffi 3.4.x)

* Fri Jan 13 2023 Jakub Bogusz <qboosh@pld-linux.org> a5c9999
- release 3

* Fri Jan 13 2023 Jakub Bogusz <qboosh@pld-linux.org> 2bf11f8
- try with CMAKE_INSTALL_LIBDIR for local nanopb

* Fri Jan 13 2023 Jakub Bogusz <qboosh@pld-linux.org> 7918565
- release 2

* Fri Jan 13 2023 Jakub Bogusz <qboosh@pld-linux.org> b91549d
- added shared-nanopb patch and system_nanopb bcond (off currently, tests fail with system nanopb 0.4.7)

* Sun Nov 20 2022 Jan Palus <atler@pld-linux.org> 2d82a57
- drop debug leftover

* Sun Nov 20 2022 Jan Palus <atler@pld-linux.org> 2371444
- up to 2.4.1

* Wed May 06 2020 Jan Rękorajski <baggins@pld-linux.org> 286f290
- fix miscompiled library on x32
- added tests
- rel 5

* Wed May 06 2020 Jan Rękorajski <baggins@pld-linux.org> 5d023ef
- cram tests fail due to missing, unchecked dependencies

* Fri May 01 2020 Jan Rękorajski <baggins@pld-linux.org> ca1ee7b
- release 4 (by relup.sh)

* Wed Apr 29 2020 Jakub Bogusz <qboosh@pld-linux.org> 6e47062
- added libdir patch (fix library install and .pc file)
- use system dyncall and nanomsg libraries
- release 3

* Fri Sep 20 2019 Arkadiusz Miśkiewicz <arekm@maven.pl> aa7e236
- rel 2; fix i686 build

